#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#include <grp.h>
#include "iolib.h"
#define PROGNAME "setuidgid"
#include "freedt.h"

int main(int argc, char **argv) {
	struct passwd *p;

	istdinit();

	if (argc < 3)
		die("usage: setuidgid account command ...");

	if (getuid() != 0)
		die("you must be root");

	p = getpwnam(argv[1]);
	if (!p)
		die("no such account");
	if (setgid(p->pw_gid) < 0)
		die("unable to setgid");
	if (setgroups(1, &p->pw_gid) < 0)
		die("unable to setgroups");
	if (setuid(p->pw_uid) < 0)
		die("unable to setuid");

	execvp(argv[2], &argv[2]);
	die("unable to exec");

	return 0; /* NOTREACHED */
}

